



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>File FileStream StreamWriter StreamReader文件读写操作方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">File FileStream StreamWriter StreamReader文件读写操作方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 09:50:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">string path = "D:\\AccountChecking\\Test.txt";<br />
string content = "abcdefg\r\nhigklmn\r\nopqrst";

//操作文件夹对象，无则创建文件夹，可以一次创建多级<br />
Directory.CreateDirectory("D:\\AccountChecking\\");

#region File-对于文件的典型操作，如复制、移动、重命名、创建、打开、删除和一次将追加到单个文件的类

//写文件<br />
File.WriteAllText(path, content, Encoding.Default);<br />
File.WriteAllLines(path, content.Split('r'), Encoding.Default);<br />
File.WriteAllBytes(path, Encoding.Default.GetBytes(content));<br />
//追加内容<br />
File.AppendAllText(path, content, Encoding.Default);<br />
//读文件<br />
string content_t = File.ReadAllText(path, Encoding.Default);<br />
string[] content_s = File.ReadAllLines(path, Encoding.Default);<br />
byte[] content_b = File.ReadAllBytes(path);

#endregion

#region FileStream-以流的形式对文件系统上的文件进行读取、写入、打开和关闭操作，既支持同步读写操作，也支持异步读写操作

//写文件<br />
using (FileStream fileStream = new FileStream(path, FileMode.Create))<br />
{<br />
    byte[] data = Encoding.Default.GetBytes(content);<br />
    fileStream.Write(data, , data.Length);//将内容写入缓冲区<br />
    //Flush()将缓冲区内容写入文件系统，后续无操作的话，在关闭或出using时会自动写入文件系统<br />
    //fileStream.Flush();<br />
    //使用using就不必显示的关闭流，它会自动关闭并释放<br />
    //fileStream.Close();<br />
}<br />
//追加内容<br />
using (FileStream fileStream = new FileStream(path, FileMode.Append))<br />
{<br />
    byte[] data = Encoding.Default.GetBytes(content);<br />
    fileStream.Write(data, , data.Length);<br />
}<br />
//读文件<br />
using (FileStream fileStream = new FileStream(path, FileMode.Open))<br />
{<br />
    byte[] data = new byte[fileStream.Length];<br />
    fileStream.Read(data, , data.Length);<br />
    string result = Encoding.Default.GetString(data);<br />
    //do something...<br />
}

#endregion

#region StreamWriter&amp;StreamReader-StreamReader实现了抽象基类TextReader类，而StreamWriter实现了抽象基类TextWriter，分别用于对流的读取与写入

//写文件<br />
using (StreamWriter streamWriter = new StreamWriter(path))<br />
{<br />
    //方法一<br />
    streamWriter.Write(content);<br />
    streamWriter.Flush();//将缓冲区内容写入磁盘<br />
    //使用using就不必显示的关闭流，它会自动关闭并释放<br />
    //streamWriter.Close();<br />
    //方法二<br />
    streamWriter.WriteLine(content.ToCharArray());//按行写入<br />
    //streamWriter.Flush();<br />
}<br />
//追加内容<br />
using (StreamWriter streamWriter = new StreamWriter(path, true))<br />
{<br />
    //方法一<br />
    streamWriter.Write(content);<br />
    streamWriter.Flush();<br />
    //方法二<br />
    streamWriter.WriteLine(content.ToCharArray());//按行追加<br />
}<br />
//读文件（StreamReader类似指针位移的操作，所以实例化多个对象）<br />
using (StreamReader streamReader_ToLine = new StreamReader(path))<br />
using (StreamReader streamReader_ToEnd = new StreamReader(path))<br />
using (StreamReader streamReader_To = new StreamReader(path))<br />
{<br />
    string msg = String.Empty;<br />
    //方法一<br />
    while (!streamReader_ToLine.EndOfStream)<br />
    {<br />
        msg = streamReader_ToLine.ReadLine();<br />
        //do something...<br />
    }<br />
    //方法二<br />
    if (!streamReader_ToEnd.EndOfStream)<br />
    {<br />
        msg = streamReader_ToEnd.ReadToEnd();<br />
        //do something...<br />
    }<br />
    //方法三<br />
    char[] data = new char[streamReader_To.BaseStream.Length];<br />
    streamReader_To.Read(data, , data.Length);<br />
    string result = new String(data);<br />
    //do something...<br />
}

#endregion</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvj51jq.html">jvm、jre、jdk</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93lzyw9.html">ffmpeg-20160701-git-bin&period;7z</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjjvjk9.html">centos7 最小化安装 无 ifconfig&comma;netstat 的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2e2j8.html">libevent和基于libevent的网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1el2d9.html">内存映射  madvise mmap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmy21k9.html">转载： Nova-Router 分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk5j0d8.html">jQuery UI 入门之实用实例分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvm369.html">【Android Developers Training】 51&period; 序言：打印内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk6lnv8.html">C&plus;&plus;异常处理机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k0n729.html">无依赖简单易用的Dynamics 365实体记录数计数器并能计算出FetchXml返回的记录数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrzww8.html">poj 2155 matrix 二维线段树 线段树套线段树</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rzdmz8.html">学习笔记DL004&colon;标量、向量、矩阵、张量，矩阵、向量相乘，单位矩阵、逆矩阵</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1n53w9.html">c&sol;C&plus;&plus;编译的程序占用的内存分为以下几个部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jk62jq.html">golang 特殊知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e42m0z9.html">odoo之带出历史订单产品</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5r10dq.html">仿照admin实现一个自定义的增删改查的组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o16dy1q.html">JavaEE编程实验 实验1 Java常用工具类编程（未完成）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvxxwj8.html">基本数据类型dict</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m23y3oq.html">C&num; delegate &lpar;001&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1revv48.html">简单rmi示例</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8meyldoq.html">有var和没有var的本质区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpk5w39.html">安装JDK详细步骤，以及环境变量配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgym38.html">AFN和SDWebImage请求网络图片的一点问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg61pd8.html">NHibernate教程&lpar;9&rpar;一1对n关联映射</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kyl149.html">JSONP&lpar;Json with padding&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pll5v8.html">201521123091 《Java程序设计》第6周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jgg4l8.html">Java中继承与多态</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjn4gy8.html">201521123045 《Java程序设计》第5周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk6r5j8.html">Java：类类型变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m401n8.html">javaScript【创建对象、创建类、成员变量、方法、公有和私有、静态】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
